#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include "imgitem.h"
#include <vector>
#include <string>
using namespace std;

extern "C" __declspec(dllexport) 
void __stdcall PDFExtractToTIFF_SetDPI(int xDPI, int yDPI);
extern "C" __declspec(dllexport)
void __stdcall PDFExtractToTIFF_SetOptions(LPCTSTR ptrKey, LPCTSTR ptrValue);
extern "C" __declspec(dllexport) 
int __stdcall PDFExtractToTIFF(const char *ptrPDFName,const char *ptrTIFFName, 
			       int bIsSinglePage,
			       const char* ownerPassword,
			       const char* userPassword);

extern "C" __declspec(dllexport)
int __stdcall PDFExtractToTIFF_EnumImages(const char *ptrPDFName, const char* ownerPassword, const char* userPassword,
										  EnumImagesProc lpEnumImagesProc);

extern "C" __declspec(dllexport)
void __stdcall PDFExtractToTIFF_SetLicenseKey(const char *lpCode);

int __stdcall MyEnumImages(int nPage, LPIMAGEINFO lpImageItem)
{
	printf("================================\n");
	printf("PageNum = %d\n", lpImageItem->nPageNum);
	printf("ImgIndex = %d\n", lpImageItem->nImgIndex);
	printf("ImgWidth = %d\n", lpImageItem->nImgWidth);
	printf("ImgHeight = %d\n", lpImageItem->nImgHeight);
	printf("Bitcount = %d\n", lpImageItem->nBitcount);
	printf("ImgFile = %s\n", lpImageItem->szImgFile);

	printf("nDestLeft = %d\n", lpImageItem->nDestLeft);
	printf("nDestTop = %d\n", lpImageItem->nDestTop);
	printf("nDestWidth = %d\n", lpImageItem->nDestWidth);
	printf("nDestHeight = %d\n", lpImageItem->nDestHeight);
	return 0;
}

int FindAllFiles(LPCTSTR szInputFilename, vector<string>& m_aryFiles)
{
	char szOutExt[_MAX_EXT];
	char szOutDrive[_MAX_DRIVE];
	char szOutDir[_MAX_DIR];
	char szOutName[_MAX_PATH];
	
	char szTempExt[_MAX_EXT];
	char szTempDrive[_MAX_DRIVE];
	char szTempDir[_MAX_DIR];
	char szTempName[_MAX_PATH];

	_splitpath(szInputFilename, szOutDrive, szOutDir, szOutName, szOutExt);	
	WIN32_FIND_DATA stFindData;
	memset(&stFindData,0,sizeof(WIN32_FIND_DATA));
	HANDLE hFind = FindFirstFile(szInputFilename,&stFindData);
	BOOL bFind = TRUE;
	while((hFind != INVALID_HANDLE_VALUE)&&(bFind))
	{
		char szInFileName[MAX_PATH];
		_splitpath(stFindData.cFileName, szTempDrive, szTempDir, szTempName, szTempExt);
		_makepath(szInFileName,szOutDrive, szOutDir, szTempName, szTempExt);

   		DWORD m_dwFileAttrib = GetFileAttributes(szInFileName);
		if(m_dwFileAttrib != INVALID_FILE_ATTRIBUTES && !(m_dwFileAttrib&FILE_ATTRIBUTE_DIRECTORY))
		{
			m_aryFiles.push_back(szInFileName);
		}
		
		bFind = FindNextFile(hFind,&stFindData);
	}
	FindClose(hFind);
	return m_aryFiles.size();
}
int main(int argc, CHAR* argv[])
{
	if(argc != 2)
	{
		printf("pdf2tif.exe C:\\test.pdf\n");
		return 0;
	}
	PDFExtractToTIFF_SetLicenseKey("XXXXXXXXXXXXXXXXXXX");

//	vector<string> aryFiles;
//	FindAllCadFiles("D:\\temp\\*.pdf", aryFiles);
//	for(int i = 0; i < aryFiles.size(); i++)
//		PDFExtractToTIFF_EnumImages(aryFiles[i].c_str(), NULL, NULL, &MyEnumImages);

	PDFExtractToTIFF_SetOptions("OutputFolder", "C:\\");
	PDFExtractToTIFF_SetOptions("FirstPage", "0");
	PDFExtractToTIFF_SetOptions("LastPage", "0");
	PDFExtractToTIFF_SetDPI(300,300);
	PDFExtractToTIFF_SetOptions("ExportJPG","0");
	PDFExtractToTIFF_SetOptions("AutoInvertBWImage","1");
	PDFExtractToTIFF_SetOptions("AutoMergeStrips","1");
	PDFExtractToTIFF_SetOptions("RemoveThumbnail","1");
	PDFExtractToTIFF_EnumImages(argv[1], NULL, NULL, &MyEnumImages);

    return 0;
}
